# Copyright (c) 2009 gocept gmbh & co. kg
# See also LICENSE.txt

import gocept.directory.interfaces
from zope.app.zopeappgenerations import getRootFolder
import zope.app.component.hooks


def evolve(context):
    root = getRootFolder(context)
    d = root['directory']
    zope.app.component.hooks.setSite(d)

    # Step 1: fix inconsistencies we introduced by manually jerking around in
    # the database.
    gocept.directory.utils.fix_inconsistent_address_resource_references(d)

    # Step 2: fix inconsistencies I introduced programmatically on import
    for network in d.networks:
        for address in network.addresses_in_use:
            if gocept.directory.interfaces.INIC.providedBy(address.resource):
                continue
            # This is a node, find the right NIC and redirect the resource
            for nic in address.resource.nics:
                if address in nic.addresses:
                    address.resource = nic
                    break
            else:
                raise RuntimeError('Could not find NIC for address')
    zope.app.component.hooks.setSite(None)
